import { tick } from '@angular/core/testing';
import { __decorate, __metadata } from 'tslib';
import { Injectable } from '@angular/core';

class FormControlMock {
    constructor(type = 'text') {
        this.nativeElement = document.createElement('input');
        this.nativeElement.setAttribute('type', type);
    }
}

function advance(f, advanceBy = 0) {
    tick(advanceBy);
    f.detectChanges();
}

var MockToastService_1;
class MockToast {
    constructor(message, context, header) {
        this.message = message;
        this.context = context;
        this.header = header;
    }
    dismiss() {
        return new Promise((resolve) => resolve());
    }
}
const ɵ0 = () => { }, ɵ1 = (message, header) => {
    return new MockToast(message, 'danger', header);
}, ɵ2 = (message, header) => {
    return new MockToast(message, 'info', header);
}, ɵ3 = (message, header) => {
    return new MockToast(message, 'success', header);
}, ɵ4 = (message, header) => {
    return new MockToast(message, 'success', header);
}, ɵ5 = () => {
    return new Promise(r => r(this));
}, ɵ6 = (name, fn) => { };
/** @dynamic */
const mockToastController = {
    dismissAll: ɵ0,
    error: ɵ1,
    message: ɵ2,
    success: ɵ3,
    warn: ɵ4,
    componentOnReady: ɵ5,
    addEventListener: ɵ6
};
/** @dynamic */
let MockToastService = MockToastService_1 = class MockToastService {
    constructor() {
        this.controller = MockToastService_1.createController();
    }
    static createController() {
        return mockToastController;
    }
    dismissAll() {
        this.controller.dismissAll();
    }
    error(message, header) {
        return this.controller.error(message, header);
    }
    message(message, header) {
        return this.controller.message(message, header);
    }
    success(message, header) {
        return this.controller.success(message, header);
    }
    warn(message, header) {
        return this.controller.warn(message, header);
    }
};
MockToastService = MockToastService_1 = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [])
], MockToastService);

/* Helpers */

/**
 * Generated bundle index. Do not edit.
 */

export { FormControlMock, MockToast, MockToastService, advance, mockToastController, ɵ0, ɵ1, ɵ2, ɵ3, ɵ4, ɵ5, ɵ6 };
//# sourceMappingURL=anjuna-angular-core-testing.js.map
